#! /usr/bin/python
# -*- coding: utf-8 -*-
"""
Created on Fri Dec 20 02:09:28 2013

@author: uha4
"""
import os, time
import os.path as path

""" Einstellungen"""

linesep = os.linesep

MMname = 'MindMap.mm'
CSVpfad = 'Arbeitspakete'
CSVvorlage = 'ID_000000000.csv'

MARK = '!@!'
Trenner = ';'  # Spalten-Trennelement in den CSV-Dateien
pfadTrenn = ' -> ' 

minCSVkeys = [ 'TAB', 'SUM', 'PF']   # Schlüsselzeilen die jedes CSV enthalten muss
nodePropOrder = ('CREATED', 'FOLDED', 'HGAP', 'ID', 'LINK', 'MODIFIED', 'POSITION', 'STYLE', 'TEXT', 'VSHIFT')

htmlStart = linesep.join(['<richcontent TYPE="NOTE"><html>',
                          '  <head>',
                          '    ',
                          '  </head>',
                          '  <body>',
                          ''])
htmlEnd = linesep.join(['  </body>','</html></richcontent>',''])


""" Programm """

nodes =[]
nodesID = {}
           

def castfloat(wert):
    """ verwandelt einen String in float, gib 'X' wenn nicht möglich"""
    wert = wert.strip()
    if wert:
        try:
            return float(wert)
        except ValueError:
            wert = wert.replace(',', '.')
            try: 
                return float(wert)
            except ValueError:
                return 'X'
    else:
        return 0.0
    

class node(object):
    lineNo = 0
    
    def __init__(self, raw, parent):
        global nodes, nodesID
        nodes.append(self)
        self.parent = parent
        self.pfad = []
        while parent:
            self.pfad.append(parent.Name)
            parent = parent.parent
        if parent:
            self.level = parent.level + 1
        self.children = []
        if type(raw) == list:
            self.code = raw[node.lineNo]
        elif type(raw) == str:
            self.code = raw
        self.Men = []
        self.Fertig = 0
        self.at = {}
        self.csv = True
        li = self.code.strip().strip('<>')
        if li[-1] == '/':  
            self.oneline = '/'
            li = li.strip('/')
        else: 
            self.oneline = ''
        words = li.split()
        for j, w in enumerate(words):
            if '=' in w:
                if w[-1] != '\"':
                    jt = j
                    while words[jt][-1] != '\"':
                        jt +=1
                    w = ' '.join(words[j:jt+1])
                    #print j, '..', jt, ' -->  ', words[j:jt+1]
                k,w = w.split('=')
                if k not in nodePropOrder:
                    print('Achtung Eignenschaft %s noch nicht vorgesehen' % k)
                self.at[k] = w.strip("\"")
        try:
            nodesID[self.at['ID']] = self
        except KeyError:
            nodesID['ID_00000'] = self
            
        if not 'TEXT' in self.at.keys():
            self.at['TEXT'] = ''
#        print('Beginne %s ...' % self.Name)
        self.endcode = '</node>'+linesep
        self.content = []
        if not self.oneline:
            node.lineNo += 1
            start = node.lineNo
            while ('<node ' not in raw[node.lineNo]) and ('</node>' not in raw[node.lineNo]):
                node.lineNo += 1
            self.content = raw[start:node.lineNo]
            while '</node>' not in raw[node.lineNo]:
                if '<node ' in raw[node.lineNo]:
                    self.children.append(node(raw, self))
                elif '</map>' in raw[node.lineNo]:
                    print('unerwartetes Baumende in Node %s' % self.Name)
                    node.lineNo += 1
                    raise IndexError
                else:
                    print('unerwartete Zeile(%i) am Ende von Node %s, ignoriert' % (node.lineNo, self.Name))
                    node.lineNo += 1
            
            self.endcode = raw[node.lineNo]
        node.lineNo += 1
#        print('... %s fertig' % self.Name)
        
        
    def gencode(self):
        cont = []
        for k in nodePropOrder:
            try:
                if self.at[k]:
                    cont.append('%s=\"%s\"' % (k, self.at[k]))
            except KeyError:
                pass
        self.code = '<node %s%s>%s' % (' '.join(cont), self.oneline, linesep)
            
        
    def dump(self):
#        print('dumpe %s' % self.Name)
        self.gencode()
        lines =[self.code]
        if not self.oneline:
            lines += self.content
            if self.children:
                for child in self.children:
#                    print('dumpe Kind %s von %s' % (child.Name, self.Name))
                    lines += child.dump()
            lines += [self.endcode]
        return lines
                
    def check(self):
        # Auf fehlenden Link überprüfen
        if not 'LINK' in self.at.keys():
            print('Knoten %s(%s) fehlt der Link, ignoriere ihn' % (self.ID, self.Name))
            return False
            
        # Link überprüfen
        if not self.ID in path.basename(self.at['LINK']):
            print('Achtung, Link in Knoten %s(%s) entspricht nichtseiner ID, ignoriere ihn' % (self.ID, self.Name))
            return False
            
        # Datei zu Link prüfen
        if not path.exists(self.at['LINK']):
            print('zum Link von Knoten %s(%s) fehlt die Datei, ignoriere sie.' % (self.ID, self.Name))
            return False
        return True
    
    def CSVsum(self):
        # CSV einlesen
        changed = False
        if not self.csv:
            return False
        if (CSVpfad not in self.at['LINK']) and ('.csv' not in self.at['LINK']):
            print('Node: %s(%s) hat keine gültige CSV-Datei' % (self.ID, self.Name))            
            return False
        dat = open(self.at['LINK'], 'r')
        self.CSV = dat.readlines()
#        print('bearbeite Knoten %s(%s):' % (self.ID, self.Name))
        dat.close()
        # wichtige Zeilen finden
        Alines = []
        minKeys = minCSVkeys[:]
        TabZNr = False
        for i, l in enumerate(self.CSV):
            if '%sTAB' % MARK in l:
                TabZNr = i+2        # Zeile in der die Tabelle beginnt
                Titel = self.CSV[i+1].strip().split(Trenner)
                minKeys.pop(minKeys.index('TAB'))
            elif MARK in l:
                Alines.append(i)
#                print('%i: %s' % (i, self.CSV[i]))
        if not TabZNr:
            for i, l in enumerate(self.CSV):
                if 'Nummer;Stunden;' in l:
                    TabZNr = i+1        # Zeile in der die Tabelle beginnt
                    Titel = self.CSV[i].strip().split(Trenner)
        if not TabZNr:
            print('Datei %s nicht auswertbar!' % self.at['LINK'])
            self.CSV = []
            return False

        for ch in self.children:
            ch.CSVsum()

       
        # Tabelle auswerten
        self.ArbSum = 0
        self.MatSum = 0
        self.Men = []
        for i, Z in enumerate(self.CSV[TabZNr:]):
            if MARK in Z:
                continue
            Z = Z.split(Trenner)
            try:
                A = castfloat(Z[1])
                M = castfloat(Z[2])
            except IndexError:
                print('konnte CSV-Datei von Knoten %s(%s) nicht einlesen (IndexError)' % (self.ID, self.Name))
                A = M = 0
            try:
                Me = Z[3].strip()
                Te = Z[5].strip()
            except IndexError:
                Me = ''
                Te = 'Unbenannt'
            
            child = node("<node TEXT=\"%s\"/>" % Te, self)
            child.ArbSum = A
            child.MatSum = M
            child.Men = [Me]
            self.children.append(child)
        del self.at['LINK']
        

    def genCSVpfad(self):
        pl = self.pfad[:]
        pl.reverse()
        pf = pfadTrenn.join(pl)
        felder = ['%sPF'%MARK, 'Name:', self.Name, '', 'Pfad:', pf]
        Zeile = Trenner.join(felder)
        Zeile += linesep
        return Zeile 
        
    def MapSum(self):
#        if not self.content and not self.ArbSum and not self.MatSum:
#            return
        toAdd = ['Arb', 'Mat', 'Men']
        Attr = 0
        try:
            if not self.ArbSum:
                ArbZ = ''
            else:
                ArbZ = '!Arbeit: %3.2f%s' % (self.ArbSum, linesep)
            Attr += 1
        except AttributeError:
            ArbZ = ''
        try:
            if not self.MatSum:
                MatZ = ''
            else:
                MatZ = '!Material: %3.2f%s' % (self.MatSum, linesep)
            Attr += 1
        except AttributeError:
            MatZ = ''
        try:
            if not self.Men:
                MenZ = ''
            else:
                MenZ = '!Beteiligte: %s%s' % (', '.join(self.Men), linesep)
            Attr += 1
        except AttributeError:
            MenZ = ''
        bodyStart = -1
        
        for i, l in enumerate(self.content):
            if MARK in l:
                pre = l.split('@')[0]
                if 'Arbeit' in l:
                    toAdd.pop(toAdd.index('Arb'))
                    self.content[i] = ''.join((pre[:-1],ArbZ))
                elif 'Material' in l:
                    toAdd.pop(toAdd.index('Mat'))
                    self.content[i] = ''.join((pre[:-1],MatZ))
                elif 'Beteiligt' in l:
                    toAdd.pop(toAdd.index('Men'))
                    self.content[i] = ''.join((pre[:-1],MenZ))
            if '<richcontent' in l and 'NOTE' in l:
                bodyStart = 0
            if '<body>' in l and bodyStart == 0:
                preT = l.split('<')[0]
                bodyStart = i
        if Attr:
            if bodyStart < 0:
                self.content.insert(0, htmlStart)
                self.content.insert(1, htmlEnd)
                bodyStart = 0
                preT = '  '
            toAdd.reverse()
            if toAdd:
                pre = '%s  <p>%s%s    ' % (preT, linesep, preT)
                post = '%s  </p>%s' % (preT, linesep)
            for Z in toAdd:
                if Z == 'Arb':
                    self.content.insert(bodyStart+1, ''.join((pre, ArbZ, post)))
                if Z == 'Mat':
                    self.content.insert(bodyStart+1, ''.join((pre, MatZ, post)))
                if Z == 'Men':
                    self.content.insert(bodyStart+1, ''.join((pre, MenZ, post)))
            self.oneline = ''
        

    # versteckte Getter für Eigenschaften        
    def getName(self):
        return self.at['TEXT']
    Name = property(getName)
    def getID(self):
        try:
            return self.at['ID']
        except KeyError:
            return 'ID_00000'
    ID = property(getID)

def read(dat):     
    # Einlesen der Mindmap
    MindDat = open(dat, 'r')
    Mind = MindDat.readlines()
    MindDat.close()
    
    lineNo = 0
    try:
        while '<node ' not in Mind[lineNo]:
            lineNo +=1
    except IndexError:
        print("!! Datei '%s' enthält keine erkennbare Mindmap !!" % MMname)
    Kopf = Mind[:lineNo]
    node.lineNo = lineNo
    root = node(Mind, False)
    lineNo = node.lineNo
    Fuss = Mind[lineNo:]
    return Kopf, root, Fuss
    
def save(dat, Kopf, root, Fuss):
    Ausg = Kopf + root.dump() + Fuss
    od = open(dat, 'w')
    od.writelines(Ausg)
    od.close()


def checkall():    
    # verwaisteDateien finden und umbenennen
    CSVs = [CSVvorlage]
    for n in nodes:
        try:
            n.csv = n.check()
            CSVs.append(path.basename(n.at['LINK']))  
        except KeyError:
            pass
    listCSVdir = os.listdir(CSVpfad)
    os.chdir(CSVpfad)
    for d in listCSVdir:
        if d not in CSVs and d[0] not in '.x':
            print('verwaiste Datei %s gefunden' %d)
            try:
                if os.system('git mv %s x%s' % (d, d)):
                    raise OSError
            except:
                print('konnte sie nicht mit GIT umbenennen, versuche es normal.')
                os.rename(d, 'x%s' % d)
    os.chdir('..')
        
if __name__ == '__main__':
    import sys, traceback
    try:
        if path.exists('Errors'):
            os.remove('Errors')
        print('lade %s ...' % MMname)
        Kopf, root, Fuss = read(MMname)
        print('überprüfe ...')
        checkall()
        root.CSVsum()
        for n in nodes:
            n.MapSum()
        print('speichere %s ...' % MMname)
        save(MMname, Kopf, root, Fuss)
        print('... fertig'+linesep)
    except:
        errfile = open('Errors', 'w')
        traceback.print_exc(file=errfile)
        errfile.close()
#        x = raw_input('bitte Taste Drücken')
        raise
#    x = raw_input('bitte Taste Drücken')





