// @ExecutionModes({ON_SINGLE_NODE})

// OpenBien-Summenskript
// Version 0.1.02 vom 7.5.2015

// Skript um in allen Knoten die Daten für Arbeit und 
// Material zu finden, und in den Atributen zu summieren
// getestet unter Freeplane-1.2.23 
// Skript in den Skripteordner des persönlichen 
// Freeplane-Einstellungsverzeichnisses kopieren oder verlinken, 
// dann steht es beim nächsten Start von Freeplane im 
// Skripte-Menü zur Verfügung.

def m = node.map

lastRunTime = m.root.createdAt
//println ' last Run at: '
//println lastRunTime
//println ' '

def findewert(inputline) {
  // gibt die Summe aller auswertbaren, 
  // alleinstehenden Zahlen einer Zeile zurück
  def wert = 0.0
  def words = inputline.split(' ')
  for (word in words) {
    word = word.replace(',', '.')
    try { 
      wert += Float.parseFloat(word)
    } 
    catch (Exception e) {
        wert = wert
    }
  }
  wert
}


def sumNode(curnode) {
  def arbeit = 0
  def material = 0
  // holen und Summieren der Atribute der Kinder
  for (kind in curnode.children) {
    sumNode(kind)
    def ka = 0
    def km = 0
    if ( kind['Arbeit'] ) {
      ka = kind['Arbeit'].num
    } 
    if (kind['Material'] ) {
      km = kind['Material'].num
    } 
    if ( ka ) {
      arbeit += ka
    }
    if ( km ) {
      material += km
    }
  }

  // überprüfung auf aktuelle Änderungen
//  println 'looking at: '+curnode.text+' - '+curnode.lastModifiedAt
  
//  if ( curnode.lastModifiedAt < lastRunTime ) {
//    return
//  }
//  println 'change found'
  
  if ("closed" in curnode.icons.icons) {  // falls "closed" Icon...
    arbeit = 0
  material = 0
  } else {
    // Ermitteln der Daten aus den Notizen
    if ( curnode.note ) {
      def notelines = curnode.note.split('\n')
      for  (line in notelines ) {
        if ( line.contains('!Arbeit') ) {
          arbeit += findewert(line)
        } else if ( line.contains('!Material') ) {
          material += findewert(line)
        }
      }
    }
  }
  
  // Ausfüllen der Attribute, bzw entfernen falls 0
  curnode['Arbeit'] = arbeit
  if ( curnode['Arbeit'].num == 0 ) {
    curnode.getAttributes().removeAll('Arbeit')
  }
  curnode['Material'] = material
  if ( curnode['Material'].num == 0) {
    curnode.getAttributes().removeAll('Material')
  }
  // Eltern die Änderung mitteilen
  if ( curnode.parent ) {
    curnode.parent.lastModifiedAt = curnode.lastModifiedAt
  }
}

sumNode(m.root)
m.root.createdAt = new Date()
